class LWTConfigClientWindow extends UWindowDialogClientWindow;

var bool bDebug;
var float DamageMult, ChunkDamage, SPDamMult;
var int MaxAdjVal;

struct DefDamType
{
	var string WeapC;
	var float PDamage;
	var float SDamage;
	var int HDamage;
};

var DefDamType WCListWeap;
var int WeapCount, Windex;

var LWTMenu confighandler;   // points to the class that has spawned our "temp" copy of the mutator

var UWindowSmallButton CloseButton, FirstButton, NextButton, PrevButton, LastButton, DeleteButton;
var UWindowSmallCloseButton CancelButton;  //Used for Update Button....
var UWindowCheckbox DebugCheckbox;
var UWindowEditControl DamMultBox;
var UWindowEditControl MaxAdjValBox;
var UWindowEditControl ChunkDamageBox;
var UWindowEditControl SPDamMultBox;
var UWindowEditControl WeapCountBox;
var UWindowEditControl CurWeapNumBox;
var UWindowEditControl WNameBox;
var UWindowEditControl PDamBox;
var UWindowEditControl SDamBox;
var UWindowEditControl HDamBox;

function Created()
{
	Windex = 0;
	LoadDefs();
	Super.Created();

	// Damage Multiplier box
	DamMultBox = UWindowEditControl(CreateWindow(class'UWindowEditControl', 40, 10, 200, 200));
	DamMultBox.Align = TA_Left;
	DamMultBox.SetText("Damage Multiplier: ");
	DamMultBox.SetValue(Right(string(DamageMult), 16));
	DamMultBox.SetNumericOnly(False);
	DamMultBox.EditBoxWidth = 64;

	// MaxAdjVal Multiplier box
	MaxAdjValBox = UWindowEditControl(CreateWindow(class'UWindowEditControl', 40, 35, 200, 200));
	MaxAdjValBox.Align = TA_Left;
	MaxAdjValBox.SetText("MaxAdjVal: ");
	MaxAdjValBox.SetValue(Right(string(MaxAdjVal), 16));
	MaxAdjValBox.SetNumericOnly(False);
	MaxAdjValBox.EditBoxWidth = 48;

	// ChunkDamage box
	ChunkDamageBox = UWindowEditControl(CreateWindow(class'UWindowEditControl', 40, 60, 200, 200));
	ChunkDamageBox.Align = TA_Left;
	ChunkDamageBox.SetText("Flak ChunkDamage: ");
	ChunkDamageBox.SetValue(Right(string(ChunkDamage), 16));
	ChunkDamageBox.SetNumericOnly(False);
	ChunkDamageBox.EditBoxWidth = 64;

	// SPDamMult box
	SPDamMultBox = UWindowEditControl(CreateWindow(class'UWindowEditControl', 40, 95, 200, 200));
	SPDamMultBox.Align = TA_Left;
	SPDamMultBox.SetText("SP Damage Multiplier: ");
	SPDamMultBox.SetValue(Right(string(SPDamMult), 16));
	SPDamMultBox.SetNumericOnly(False);
	SPDamMultBox.EditBoxWidth = 64;

	// WeapName
	WNameBox = UWindowEditControl(CreateWindow(class'UWindowEditControl', 10, 125, 260, 280));
	WNameBox.Align = TA_Left;
	WNameBox.SetValue((Right(string(Windex+1), 16)));
	WNameBox.SetFont(F_Bold);
	if (WCListWeap.WeapC == "")
		WNameBox.SetText("Empty List.  Run Mutator First.");
	else
		WNameBox.SetText(WCListWeap.WeapC);
	WNameBox.EditBoxWidth = 24;
	WNameBox.EditBox.bCanEdit = False;

	// First button
	FirstButton = UWindowSmallButton(CreateWindow(class'UWindowSmallButton', 40, 155, 24, 24));
	FirstButton.SetText("<<");
	FirstButton.NotifyWindow = Self;

	// Prev button
	PrevButton = UWindowSmallButton(CreateWindow(class'UWindowSmallButton', 70, 155, 16, 16));
	PrevButton.SetText("<");
	PrevButton.NotifyWindow = Self;

	// Next button
	NextButton = UWindowSmallButton(CreateWindow(class'UWindowSmallButton', 100, 155, 16, 16));
	NextButton.SetText(">");
	NextButton.NotifyWindow = Self;

	// Last button
	LastButton = UWindowSmallButton(CreateWindow(class'UWindowSmallButton', 120, 155, 24, 24));
	LastButton.SetText(">>");
	LastButton.NotifyWindow = Self;

	//Delete button
	DeleteButton = UWindowSmallButton(CreateWindow(class'UWindowSmallButton', 175, 155, 48, 48));
	DeleteButton.SetText("Delete");
	DeleteButton.NotifyWindow = Self;

	// PDamBox
	PDamBox = UWindowEditControl(CreateWindow(class'UWindowEditControl', 40, 185, 200, 200));
	PDamBox.Align = TA_Left;
	PDamBox.SetValue(Right(string(WCListWeap.PDamage), 16));
	PDamBox.SetText("Primary Damage: ");
	PDamBox.SetNumericOnly(False);
	PDamBox.EditBoxWidth = 64;
	if (WCListWeap.PDamage == 0.0) PDamBox.EditBox.bCanEdit = False;

	// SDamBox
	SDamBox = UWindowEditControl(CreateWindow(class'UWindowEditControl', 40, 205, 200, 200));
	SDamBox.Align = TA_Left;
	SDamBox.SetValue(Right(string(WCListWeap.SDamage), 16));
	SDamBox.SetText("Secondary Damage: ");
	SDamBox.SetNumericOnly(False);
	SDamBox.EditBoxWidth = 64;
	if (WCListWeap.SDamage == 0.0) SDamBox.EditBox.bCanEdit = False;

	// HDamBox
	HDamBox = UWindowEditControl(CreateWindow(class'UWindowEditControl', 40, 225, 200, 200));
	HDamBox.Align = TA_Left;
	HDamBox.SetValue(Right(string(WCListWeap.HDamage), 16));
	HDamBox.SetText("HitDamage: ");
	HDamBox.SetNumericOnly(False);
	HDamBox.EditBoxWidth = 32;
	if (WCListWeap.HDamage == 0) HDamBox.EditBox.bCanEdit = False;

	// Weapon Count
	WeapCountBox = UWindowEditControl(CreateWindow(class'UWindowEditControl', 20, 255, 160, 180));
	WeapCountBox.Align = TA_Left;
	WeapCountBox.SetText("Total Weapons: ");
	WeapCountBox.SetValue((Right(string(WeapCount), 16)));
	WeapCountBox.SetNumericOnly(False);
	WeapCountBox.EditBoxWidth = 24;
	WeapCountBox.EditBox.bCanEdit = False;

	// Debug box
	DebugCheckBox = UWindowCheckbox( CreateControl( class'UWindowCheckbox', 20, 275, 162, 1 ) );
	DebugCheckBox.SetText("Enable Logging:");
	DebugCheckBox.SetFont(F_Normal);
	DebugCheckBox.bChecked = bDebug;
	DebugCheckBox.NotifyWindow = Self;

	// Update button -- not a close button because we need to do some special stuff when
	// closing via this button (ie, save configuration settings..).
	CloseButton = UWindowSmallButton(CreateWindow(class'UWindowSmallButton', 80 , 305, 48, 16));
	CloseButton.SetText("Update");
	CloseButton.NotifyWindow = Self;

	// Cancel button
	CancelButton = UWindowSmallCloseButton(CreateWindow(class'UWindowSmallCloseButton', 140, 305, 48, 16));
	CancelButton.SetText("Cancel");

}

function Notify( UWindowDialogControl C, byte E )
{
	Super.Notify( C, E );

	switch(E)
	{
		case DE_Change:
			switch(C)
			{
				case DebugCheckbox:
				case ChunkDamagebox:
				case DamMultbox:
				case MaxAdjValbox:
				case SPDamMultbox:
				case PDamBox:
				case SDamBox:
				case HDamBox:
					SaveValues();
					break;
			}
		case DE_Click:
			switch(C)
			{
				case FirstButton:
					SaveValues();
					Windex = 0;
					LoadCurWeap();
					break;

				case NextButton:
					SaveValues();
					if (Windex < WeapCount - 1) Windex++;
					LoadCurWeap();
					break;

				case PrevButton:
					SaveValues();
					if (Windex > 0) Windex--;
					LoadCurWeap();
					break;

				case LastButton:
					SaveValues();
					Windex = WeapCount - 1;
					LoadCurWeap();
					break;

				case DeleteButton:
					DeleteWeap();
					LoadCurWeap();
					break;

				case CloseButton:
					SaveValues();
					confighandler.TmpMut.SaveConfig();  // call SaveConfig() in the temp mutator
					confighandler.TmpMut.Destroy();     // remove the temp mutator on exit
					ParentWindow.Close();
					break;
			}
	}
}

function SaveValues()  // save local variables on menu item change
{
	bDebug = DebugCheckBox.bChecked;
	ChunkDamage = float(ChunkDamageBox.GetValue());
	DamageMult = float(DamMultBox.GetValue());
	MaxAdjVal = int(MaxAdjValBox.GetValue());
	SPDamMult = float(SPDamMultBox.GetValue());
	WCListWeap.PDamage = float(PDamBox.GetValue());
	WCListWeap.SDamage = float(SDamBox.GetValue());
	WCListWeap.HDamage = float(HDamBox.GetValue());
	SaveDefs();
}

function SaveDefs()  // save changes to the temp mutator
{
	confighandler.TmpMut.bDebug = bDebug;
	confighandler.TmpMut.ChunkDamage = ChunkDamage;
	confighandler.TmpMut.DamageMult = DamageMult;
	confighandler.TmpMut.MaxAdjVal = MaxAdjVal;
	confighandler.TmpMut.SPDamMult = SPDamMult;
	confighandler.TmpMut.SetWCListPD(Windex, WCListWeap.PDamage);
	confighandler.TmpMut.SetWCListSD(Windex, WCListWeap.SDamage);
	confighandler.TmpMut.SetWCListHD(Windex, WCListWeap.HDamage);
}

function LoadDefs()  // load current default settings from the temp mutator
{
	local int i;

	bDebug = confighandler.TmpMut.bDebug;
	ChunkDamage = confighandler.TmpMut.ChunkDamage;
	DamageMult = confighandler.TmpMut.DamageMult;
	MaxAdjVal = confighandler.TmpMut.MaxAdjVal;
	SPDamMult = confighandler.TmpMut.SPDamMult;
	WeapCount = confighandler.TmpMut.WeapCount;
	if (WeapCountBox != None) WeapCountBox.SetValue(Right(string(WeapCount), 16));
	LoadCurWeap();
	class'LWT'.default.bInConfig = False;
}

function LoadCurWeap()  // load 1 weapon and its values from temp mutator
{
	if (Windex < 0) Windex = 0;
	WCListWeap.WeapC = confighandler.TmpMut.GetWCListElement(Windex).WeapC;
	WCListWeap.PDamage = confighandler.TmpMut.GetWCListElement(Windex).PDamage;
	WCListWeap.SDamage = confighandler.TmpMut.GetWCListElement(Windex).SDamage;
	WCListWeap.HDamage = confighandler.TmpMut.GetWCListElement(Windex).HDamage;
	if (PDamBox != None)
		{ PDamBox.SetValue(Right(string(WCListWeap.PDamage), 16)); if (WCListWeap.PDamage == 0.0) PDamBox.EditBox.bCanEdit = False; else PDamBox.EditBox.bCanEdit = True; }
	if (SDamBox != None)
		{ SDamBox.SetValue(Right(string(WCListWeap.SDamage), 16)); if (WCListWeap.SDamage == 0.0) SDamBox.EditBox.bCanEdit = False; else SDamBox.EditBox.bCanEdit = True; }
	if (HDamBox != None)
		{ HDamBox.SetValue(Right(string(WCListWeap.HDamage), 16)); if (WCListWeap.HDamage == 0) HDamBox.EditBox.bCanEdit = False; else HDamBox.EditBox.bCanEdit = True; }
	if (WNameBox != None)
	{
		if (WCListWeap.WeapC == "")
			WNameBox.SetText("Empty List.  Run Mutator First.");
		else
			WNameBox.SetText(WCListWeap.WeapC);
		WNameBox.SetValue(Right(string(Windex+1), 16));
	}
}

function DeleteWeap()  // Deletes current weapon and moves rest of array down 1 spot
{
	local int i;

	if (WeapCount > 0) WeapCount--;

	for (i=Windex; confighandler.TmpMut.GetWCListElement(i).WeapC != ""; i++)
	{
		confighandler.TmpMut.SetWCListWeapC(i, confighandler.TmpMut.GetWCListElement(i+1).WeapC);
		confighandler.TmpMut.SetWCListPD(i, confighandler.TmpMut.GetWCListElement(i+1).PDamage);
		confighandler.TmpMut.SetWCListSD(i, confighandler.TmpMut.GetWCListElement(i+1).SDamage);
		confighandler.TmpMut.SetWCListHD(i, confighandler.TmpMut.GetWCListElement(i+1).HDamage);
	}
	if ((Windex >= WeapCount) && (WeapCount != 0)) Windex = WeapCount - 1;
	confighandler.TmpMut.WeapCount = WeapCount;
	if (WeapCountBox != None) WeapCountBox.SetValue(Right(string(WeapCount), 16));
}

defaultproperties
{
}
